#!/bin/bash
cmd_msg(){
	cmd=$1
	if type $cmd 2>/dev/null 1>/dev/null; then
		return 1
	else
		echo "コマンド「${cmd}」がインストールされていません"
		echo "インストール後に再度実行してください"
		exit 1
	fi
}

cmd_msg system_profiler
cmd_msg uname
cmd_msg sw_vers
cmd_msg getconf
cmd_msg iconv

if [ $# -ne 1 ]; then
	read -p "資産管理番号を入力してください: " outdir
	if [ ! -n "$outdir" ]; then
	   echo "資産管理番号を入力してください"
	   exit 1
	fi
else
	outdir="result"
fi

if [ ! -e $outdir ]; then
	mkdir $outdir
fi
cd $outdir

last -1 -t console | awk '{printf "%s,%s %s %s ", $1,$4,$5,$6}' > lastlogin
date +%Y >> lastlogin

system_profiler SPHardwareDataType > hardware
uname -n > hostname
sw_vers > os
getconf LONG_BIT > arch
system_profiler SPMemoryDataType | egrep "Size|BANK" > mem
system_profiler SPSerialATADataType | egrep "Capacity|Model" > physical_disk
system_profiler SPStorageDataType | egrep "Available|Capacity|Mount Point" > logical_disk
system_profiler SPDisplaysDataType | egrep "Chipset Model|VRAM \(Total\)|VRAM \(Dynamic, Max\)|Resolution|Pixel Depth" > video
system_profiler SPNetworkDataType -xml > nics
system_profiler SPApplicationsDataType -xml > app_tmp

if [ -e app ]; then
	rm app
fi
cat app_tmp | while read line
do
	echo $line | iconv -f UTF-8-MAC -t UTF-8 >> app
done

system_profiler SPHardwareDataType -xml > hardware.xml
system_profiler SPMemoryDataType -xml > mem.xml
system_profiler SPSerialATADataType -xml > physical_disk.xml
system_profiler SPParallelATADataType -xml > pata_disk.xml
system_profiler SPNVMeDataType -xml > nvme_disk.xml
system_profiler SPStorageDataType -xml > logical_disk.xml
system_profiler SPDisplaysDataType -xml > video.xml
exit 0